﻿<%@ Page Language="C#" Trace="False" Debug="False" %>
<%@ Import Namespace="System.Web.Security" %>
<%@ Assembly Name="RS232" %>
<script language="C#" runat="server">
Int32 deviceCommPort = Int32.Parse(ConfigurationSettings.AppSettings["DeviceCommPort"]);
CMediaRs232 moRS232 = new CMediaRs232();

void Port_IsClosed()
{
  chkCts.Checked = false;
  chkDsr.Checked = false;
  chkDcd.Checked = false;
  chkRi.Checked = false;
  chkDtr.Checked = false;
  chkDtr.Enabled = false;
  chkRts.Checked = false;
  chkRts.Enabled = false;
  chkBrk.Checked = false;
  chkBrk.Enabled = false;
  btnReadIn.Enabled = false;
  btnSetOut.Enabled = false;
  btnTurnOff.Visible = false;
  btnTurnOn.Visible = true;
  lblError.Text = "Device is turned off.";
}

void Port_IsOpen()
{
  chkDtr.Enabled = true;
  chkRts.Enabled = true;
  chkBrk.Enabled = true;
  btnReadIn.Enabled = true;
  btnSetOut.Enabled = true;
  btnTurnOff.Visible = true;
  btnTurnOn.Visible = false;

  if (Application["myDtr"] != null)
   chkDtr.Checked = (Boolean) Application["myDtr"];
  else
    moRS232.Dtr = false;

  if (Application["myRts"] != null)
    chkRts.Checked = (Boolean) Application["myRts"];
  else
    moRS232.Rts = false;

  if (Application["myBreak"] != null)
    chkBrk.Checked = (Boolean) Application["myBreak"];
  else
    moRS232.Break = false;

  lblError.Text = "Device is turned on.";
}

void Turn_On(object sender, System.EventArgs e)
{
  if (Application["myPort"] == null)
  {
    moRS232.Port = deviceCommPort;          // COM1
    moRS232.BaudRate = 2400;        // 2400 baud rate
    moRS232.DataBit = 8;          // 8 data bits
    moRS232.StopBit = CMediaRs232.DataStopBit.StopBit_1;    // 1 Stop bit
    moRS232.Parity = CMediaRs232.DataParity.Parity_None;    // No Parity
    moRS232.Timeout = 500;          // 500 ms of timeout admitted to get all required bytes (play with it)
    try
    {
      moRS232.Open();
      Application["myPort"] = moRS232;
      Port_IsOpen();
    }
    catch (Exception eX)
    {
      //lblError.Text = eX.ToString();
      lblError.Text = "Error control serial port - try restart IIS";
      btnReadIn.Enabled = false;
      btnSetOut.Enabled = false;
    }
  }
  else
  {
    moRS232 = (CMediaRs232) Application["myPort"];
    if (moRS232.IsOpen)
      Port_IsOpen();
    else
      Port_IsClosed();
  }
}

void Turn_Off(object sender, System.EventArgs e)
{
  if (Application["myPort"] != null)
  {
    moRS232 = (CMediaRs232) Application["myPort"];
    if (moRS232.IsOpen)
    {
      moRS232.Close();
      Application["myPort"] = null;
      Application["myDtr"] = null;
      Application["myRts"] = null;
      Application["myBreak"] = null;
    }
  }
  Port_IsClosed();
}

void Read_Input(object sender, System.EventArgs e)
{
  if (Application["myPort"] != null)
  {
    moRS232 = (CMediaRs232) Application["myPort"];
    if (moRS232.IsOpen)
    {
      chkCts.Checked = moRS232.Cts;
      chkDsr.Checked = moRS232.Dsr;
      chkDcd.Checked = moRS232.Dcd;
      chkRi.Checked = moRS232.Ri;
    }
    else
      Port_IsClosed();
  }
  else
    Port_IsClosed();
}

void Set_Output(object sender, System.EventArgs e)
{
  if (Application["myPort"] != null)
  {
    moRS232 = (CMediaRs232) Application["myPort"];
    if (moRS232.IsOpen)
    {
      moRS232.Dtr = chkDtr.Checked;
      Application["myDtr"] = chkDtr.Checked;
      moRS232.Rts = chkRts.Checked;
      Application["myRts"] = chkRts.Checked;
      moRS232.Break = chkBrk.Checked;
      Application["myBreak"] = chkBrk.Checked;
      Read_Input(sender,e);
    }
    else
      Port_IsClosed();
  }
  else
    Port_IsClosed();
}

void Page_Load(object sender, System.EventArgs e)
{
  ltrDevId.Text = deviceCommPort.ToString();
  if (!IsPostBack)
  {
    moRS232 = (CMediaRs232) Application["myPort"];
    if (Application["myPort"] != null)
    {
      moRS232 = (CMediaRs232) Application["myPort"];
      if (moRS232.IsOpen)
        Port_IsOpen();
      else
        Port_IsClosed();
    }
    else
      Port_IsClosed();
  }
}

void Logout(Object sender, EventArgs E)
{
  FormsAuthentication.SignOut();
  Response.Redirect("Login.aspx",true);
}

</script><?xml version="1.0" encoding="utf-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="cs-CZ" lang="cs-CZ" dir="ltr">
  <head>
    <meta http-equiv="Content-type" content="text/html; charset=utf-8" />
    <meta http-equiv="Imagetoolbar" content="no" />
    <meta http-equiv="MSThemeCompatible" content="no" />
    <meta name="MSSmartTagsPreventParsing" content="true" />
    <title>Control Device on serial port</title>
  </head>
  <body>
    <form runat="server">
      <fieldset style="width:480px; padding:12px;">
        <legend>Device on COM<asp:Literal Id="ltrDevId" RunAt="server" /><br /></legend>
        <div style="clear:all;">
          <asp:Label Id="lblError" Font-Bold="true" RunAt="server" />
        </div>
        <fieldset style="width:240px; clear:none; padding:12px;">
          <legend>Input Status</legend>
          <asp:CheckBox id="chkCts" Enabled="False" runat="server" Text="CTS" />
          <asp:CheckBox id="chkDsr" Enabled="False" runat="server" Text="DSR" />
          <asp:CheckBox id="chkDcd" Enabled="False" runat="server" Text="DCD" />
          <asp:CheckBox id="chkRi" Enabled="False" runat="server" Text="RI" />
          <br /><br />
          <asp:Button Id="btnReadIn" OnClick="Read_Input" runat="server" Text="Read input" />
        </fieldset>
        <fieldset style="width:200px; clear:none; padding:12px;">
          <legend>Output Control<br /></legend>
          <asp:CheckBox id="chkDtr" AutoPostBack="true" OnCheckedChanged="Set_Output" runat="server" Text="DTR" />
          <asp:CheckBox id="chkRts" AutoPostBack="true" OnCheckedChanged="Set_Output" runat="server" Text="RTS" />
          <asp:CheckBox id="chkBrk" AutoPostBack="true" OnCheckedChanged="Set_Output" runat="server" Text="BRK" />
          <br /><br />
          <asp:Button Id="btnSetOut" OnClick="Set_Output" runat="server" Text="Set output" />
        </fieldset>
        <br /><br />
        <asp:Button Id="btnTurnOff" OnClick="Turn_Off" runat="server" Text="Turn Off" />
        <asp:Button Id="btnTurnOn" OnClick="Turn_On" runat="server" Text="Turn On" />
        <asp:Button Text="Logout" OnClick="Logout" RunAt="server" />
      </fieldset>
    </form>
  </body>
</html>
